
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

public class Main
{

    public Main() throws IOException
    {

    }

    private void solve() throws IOException
    {
        int n = nextInt(), x = nextInt();
        long a[] = new long[n];
        int sz = 0;
        for (int i = 0; i < n; i++)
        {
            a[i] = parse(next());
        }
        long l = parse(next());
        long r = parse(next());
        sort(a);
        long b[] = new long[n];
        for (int i = 0; i < n; i++)
        {
            if (l <= a[i] && a[i] <= r)
            {
                b[sz++] = a[i];
            }
        }
        if (sz == 0 || b[0] > l + 1 || b[sz - 1] < r - 1)
        {
            out.println(r - l - 1 - sz);
        }
        else
        {
            for (int i = 1; i < sz; i++)
            {
                if (b[i] - b[i - 1] >= 3)
                {
                    out.println(r - l - 1 - sz);
                    return;
                }
            }
            out.println(-1);
        }
    }

    long parse(String s)
    {
        long cur = 0;
        int val = 0;
        for (int j = 0; j < s.length(); j++)
        {
            if (s.charAt(j) == '.')
            {
                cur = cur * 256 + val;
                val = 0;
            }
            else
            {
                val = val * 10 + (s.charAt(j) - '0');
            }
        }
        cur = cur * 256 + val;
        return cur;
    }

    void sort(int a[])
    {
        Random rand = new Random();
        int n = a.length;
        for (int i = 0; i < n; i++)
        {
            int ind = rand.nextInt(i + 1);
            int t = a[i];
            a[i] = a[ind];
            a[ind] = t;
        }
        Arrays.sort(a);
    }

    void sort(long a[])
    {
        Random rand = new Random();
        int n = a.length;
        for (int i = 0; i < n; i++)
        {
            int ind = rand.nextInt(i + 1);
            long t = a[i];
            a[i] = a[ind];
            a[ind] = t;
        }
        Arrays.sort(a);
    }

    public static void main(String[] args) throws IOException
    {
        new Main().run();
    }

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    PrintWriter out = new PrintWriter(System.out);
    String next() throws IOException
    {
        while (st == null || !st.hasMoreTokens())
        {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException
    {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException
    {
        return Long.parseLong(next());
    }

    private void run() throws IOException
    {
        solve();
        out.close();
    }

}