import random
import math
random.seed('personal01/ipvx')

class TestGen:
    def __init__(self):
        self.test_number = 0


    def generate_samples(self):
        print('Generating samples...')
        self.print_test(4, ['123.123.123.123', '123.123.123.125'], '123.123.123.121', '123.123.123.125')
        self.print_test(4, ['123.123.123.123', '123.123.123.125'], '123.123.123.122', '123.123.123.125')
    

    def generate_first_group_of_tests(self):
        print('Generating subtask1...')
        self.print_test(1, ['255', '254'], '254', '255')
        self.print_test(1, ['255', '254'], '25', '255')
        self.print_test(1, ['255', '254'], '25', '26')
        self.print_test(1, ['233', '234'], '232', '235')
        for n in [0, 10, 50, 100, 200, 254, 255, 256]:
            addresses = set()
            addrs = []
            for i in range(n):
                address = random.randint(0, 255)
                while address in addresses:
                    address = random.randint(0, 255)
                addresses.add(address)
                addrs.append(str(address))
            a = random.randint(0, 254)
            b = str(random.randint(a + 1, 255))
            a = str(a)
            self.print_test(1, addrs, a, b)
        addrs = [i for i in range(0, 127)] + [i for i in range(129, 256)]
        random.shuffle(addrs)
        self.print_test(1, list(map(str, addrs)), '0', '255')
        addrs = [i for i in range(0, 127)] + [i for i in range(128, 256)]
        random.shuffle(addrs)
        self.print_test(1, list(map(str, addrs)), '0', '255')
        addrs = [i for i in range(0, 256)]
        random.shuffle(addrs)
        self.print_test(1, list(map(str, addrs)), '0', '255')
    
    def gen_trash(self, n, x, prefix):
        addrs = []
        if len(prefix) == 0:
            return []
        addresses = set()
        for i in range(n):
            addr = []
            for j in range(x - 1):
                part = random.randint(0, 255)
                addr.append(part)
            while addr == prefix:
                addr = []
                for j in range(x - 1):
                    part = random.randint(0, 255)
                    addr.append(part)
            addr.append(random.randint(0, 255))
            addr = list(map(str, addr))
            while '.'.join(addr) in addresses:
                addr[-1] = str(random.randint(0, 255))
            addr = '.'.join(addr)
            addresses.add(addr)
            addrs.append(addr)
        return addrs

    def generate_second_group_of_tests(self):
        print('Generating subtask2...')
        self.print_test(4, ['255.255.255.255', '255.255.255.254'], '255.255.255.254', '255.255.255.255')
        self.print_test(4, ['255.255.255.255', '255.255.254.254'], '255.255.255.254', '255.255.255.255')
        self.print_test(4, ['255.255.254.255', '255.255.254.254'], '255.255.255.254', '255.255.255.255')
        self.print_test(4, ['254.255.255.255', '254.255.255.254'], '255.255.255.254', '255.255.255.255')
        for n in [0, 10, 1000, 10**5]:
            for x in [1, 2, 4, 8]:
                if 256**x < n:
                    continue
                addresses = set()
                addrs = []
                for i in range(n):
                    addr = []
                    for j in range(x):
                        part = random.randint(0, 255)
                        addr.append(part)
                    addr = '.'.join(map(str, addr))
                    while addr in addresses:
                        addr = []
                        for j in range(x):
                            part = random.randint(0, 255)
                            addr.append(part)
                        addr = '.'.join(map(str, addr))
                    addresses.add(addr)
                    addrs.append(addr)
                parts = []
                for i in range(x - 1):
                    part = random.randint(0, 255)
                    parts.append(part)
                al = random.randint(0, 254)
                parts1 = parts + [str(al)]
                parts2 = parts + [str(random.randint(al + 1, 255))]
                a = '.'.join(map(str, parts1))
                b = '.'.join(map(str, parts2))
                self.print_test(x, addrs, a, b)

        n = 10**5
        x = 8
        prefix = [127, 0, 0, 1, 127, 0, 0]
        jprefix = '.'.join(map(str, prefix))
        addrs = [(jprefix + '.' + str(i)) for i in range(0, 127)] + [(jprefix + '.' + str(i)) for i in range(129, 256)]
        addrs = addrs + self.gen_trash(n - len(addrs), x, prefix)
        random.shuffle(addrs)
        self.print_test(x, list(map(str, addrs)), jprefix + '.0', jprefix + '.255')
        addrs = [(jprefix + '.' + str(i)) for i in range(0, 127)] + [(jprefix + '.' + str(i)) for i in range(128, 256)]
        addrs = addrs + self.gen_trash(n - len(addrs), x, prefix)
        random.shuffle(addrs)
        self.print_test(x, list(map(str, addrs)), jprefix + '.0', jprefix + '.255')
        addrs = [(jprefix + '.' + str(i)) for i in range(0, 256)]
        addrs = addrs + self.gen_trash(n - len(addrs), x, prefix)
        random.shuffle(addrs)
        self.print_test(x, list(map(str, addrs)), jprefix + '.0', jprefix + '.255')

    def print_test(self, x, addresses, a, b):
        self.test_number += 1
        print('Generating test %d' % self.test_number)
        
        test_name = '{0:0=2d}'.format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(addresses), x, file=test_file)
        if len(addresses) != 0:
            print('\n'.join(map(str, addresses)), file=test_file)
        print(a, file=test_file)
        print(b, file=test_file)
        test_file.close()


    def generate_all_tests(self):
        #Samples
        self.generate_samples() 
        
        #First group of tests
        self.generate_first_group_of_tests()
        
        #Second group of tests
        self.generate_second_group_of_tests()

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
