import random
import math
import sys
random.seed('personal01/ipvx')

class TestGen:
    def __init__(self):
        self.test_number = int(sys.argv[1])


    def gen_trash(self, n, x, prefix):
        addrs = []
        if len(prefix) == 0:
            return []
        addresses = set()
        for i in range(n):
            addr = []
            for j in range(x - 1):
                part = random.randint(0, 255)
                addr.append(part)
            while addr == prefix:
                addr = []
                for j in range(x - 1):
                    part = random.randint(0, 255)
                    addr.append(part)
            addr.append(random.randint(0, 255))
            addr = list(map(str, addr))
            while '.'.join(addr) in addresses:
                addr[-1] = str(random.randint(0, 255))
            addr = '.'.join(addr)
            addresses.add(addr)
            addrs.append(addr)
        return addrs
    
    def generate_third_group_of_tests(self):
        print('Generating subtask3...')
        x = 8
        prefix = [127, 0, 0, 1, 127, 0]
        jprefix = '.'.join(map(str, prefix))
        addrs = []
        for i in range(256):
            for j in range(256):
                if ((i == 127) and (j == 255)) or ((i == 128) and (j == 1)):
                    continue
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)
        addrs = []
        for i in range(256):
            for j in range(256):
                if ((i == 127) and (j == 255)) or ((i == 128) and (j == 0)):
                    continue
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)
        addrs = []
        for i in range(256):
            for j in range(256):
                if ((i == 127) and (j == 255)):
                    continue
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)
        addrs = []
        for i in range(256):
            for j in range(256):
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)

        prefix = [127, 0, 0, 1, 127]
        jprefix = '.'.join(map(str, prefix))
        addrs = []
        start = [7, 250, 127]
        while len(addrs) < 10**5:
            addrs.append(jprefix + '.' + '.'.join(map(str, start)))
            j = 2
            start[j] += 1
            while start[j] == 256:
                start[j] = 0
                start[j - 1] += 1
                j -= 1
        last = addrs[-1]
        random.shuffle(addrs)
        a = jprefix + '.' + '7.250.126'
        b = last
        self.print_test(x, addrs, a, b)
        a = jprefix + '.' + '7.250.125'
        b = last
        self.print_test(x, addrs, a, b)

        def add(now):
            now[-1] += 1
            j = len(now) - 1
            while now[j] == 256:
                now[j] = 0
                now[j - 1] += 1
                j -= 1
            return now

        addrs = []
        now = [127, 0, 0, 1, 0, 0, 0, 0]
        while len(addrs) < 10**5:
            addrs.append('.'.join(map(str, now)))
            now = add(now)
            now = add(now)
        random.shuffle(addrs)
        a = '127.0.0.0.255.255.255.255'
        b = '.'.join(map(str, add(now)))
        self.print_test(x, addrs, a, b)
        a = '127.0.0.1.0.0.0.0'
        b = '.'.join(map(str, add(add(now))))
        self.print_test(x, addrs, a, b)
        a = '127.0.0.1.0.2.255.255'
        b = '.'.join(map(str, add(add(now))))
        self.print_test(x, addrs, a, b)
        a = '127.0.0.1.0.2.255.255'
        b = '.'.join(map(str, add(now)))
        self.print_test(x, addrs, a, b)


    def generate_fourth_group_of_tests(self):
        print('Generating subtask4...')
        x = 8
        prefix = [127, 0, 0, 1, 127, 0]
        jprefix = '.'.join(map(str, prefix))
        addrs = []
        for i in range(256):
            for j in range(256):
                if ((i == 120) and (j == 255)) or ((i == 121) and (j == 1)) or ((i == 121) and (j == 3)):
                    continue
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)
        addrs = []
        for i in range(256):
            for j in range(256):
                if ((i == 120) and (j == 255)) or ((i == 121) and (j == 1)) or ((i == 121) and (j == 2)):
                    continue
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)
        addrs = []
        for i in range(256):
            for j in range(256):
                if ((i == 120) and (j == 255)) or ((i == 121) and (j == 0)):
                    continue
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)
        addrs = []
        for i in range(256):
            for j in range(256):
                if ((i == 120) and (j == 255)):
                    continue
                addrs.append(jprefix + '.' + '.'.join([str(i), str(j)]))
        random.shuffle(addrs)
        a = jprefix + '.' + '0.3'
        b = jprefix + '.' + '255.250'
        self.print_test(x, addrs, a, b)

        def add(now):
            now[-1] += 1
            j = len(now) - 1
            while now[j] == 256:
                now[j] = 0
                now[j - 1] += 1
                j -= 1
            return now

        addrs = []
        now = [127, 0, 0, 1, 127, 0, 0, 1]
        while len(addrs) < 10**5:
            addrs.append('.'.join(map(str, now)))
            now = add(now)
            now = add(now)
        random.shuffle(addrs)
        a = '127.0.0.1.127.0.0.0'
        b = '.'.join(map(str, add(now)))
        self.print_test(x, addrs, a, b)
        a = '127.0.0.1.127.0.0.0'
        b = '.'.join(map(str, add(add(now))))
        self.print_test(x, addrs, a, b)
        a = '127.0.0.1.126.255.255.255'
        b = '.'.join(map(str, add(add(now))))
        self.print_test(x, addrs, a, b)
        a = '127.0.0.1.126.255.255.255'
        b = '.'.join(map(str, add(now)))
        self.print_test(x, addrs, a, b)

        a = '0.0.0.0.0.0.0.0'
        b = '255.255.255.255.255.255.255.255'
        self.print_test(x, addrs, a, b)
        a = '0.0.127.255.255.0.0.0'
        b = '255.255.127.127.0.0.2.255'
        self.print_test(x, addrs, a, b)
        a = '0.0.0.0.0.0.0.0'
        b = '0.0.0.0.1.0.0.0'
        self.print_test(x, addrs, a, b)
        a = '127.0.0.1.126.5.0.0'
        b = '127.0.0.1.127.0.0.0'
        self.print_test(x, addrs, a, b)

    def print_test(self, x, addresses, a, b):
        self.test_number += 1
        print('Generating test %d' % self.test_number)
        
        test_name = '{0:0=2d}'.format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(addresses), x, file=test_file)
        if len(addresses) != 0:
            print('\n'.join(map(str, addresses)), file=test_file)
        print(a, file=test_file)
        print(b, file=test_file)
        test_file.close()


    def generate_all_tests(self):
        #Third group of tests
        self.generate_third_group_of_tests()

        #Fourth group of tests
        self.generate_fourth_group_of_tests()

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
