
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

public class Main
{

    public Main() throws IOException
    {

    }

    private void solve() throws IOException
    {
        int n = nextInt();
        int a[] = new int[n];
        for (int i = 0; i < n; i++)
        {
            a[i] = nextInt();
        }
        int m = nextInt();
        int b[] = new int[m];
        for (int i = 0; i < m; i++)
        {
            b[i] = nextInt();
        }
        int[]x = get(a);
        int[]y = get(b);
        int ans = 0;
        for (int i = 0; i <= Math.min(n, m); i++)
        {
            ans = Math.max(ans, i + Math.min(x[i], y[i]));
        }
        out.println(ans);
    }

    int[] get(int a[])
    {
        int n = a.length;
        int res[] = new int[n + 1];
        for (int i = 0; i <= n; i++)
        {
            res[i] = (int) -1e9;
        }
        int zero = 0;
        int one = 0;
        for (int i = 0; i < n; i++)
        {
            one += a[i];
        }
        res[0] = one;
        for (int i = 0; i < n; i++)
        {
            if (a[i] == 0)
            {
                zero++;
                res[zero] = Math.max(res[zero], one);
            }
            else
            {
                one--;
            }
        }
        for (int i = n - 1; i >= 0; i--)
        {
            res[i] = Math.max(res[i + 1], res[i]);
        }
        return res;
    }

    void sort(int a[])
    {
        Random rand = new Random();
        int n = a.length;
        for (int i = 0; i < n; i++)
        {
            int ind = rand.nextInt(i + 1);
            int t = a[i];
            a[i] = a[ind];
            a[ind] = t;
        }
        Arrays.sort(a);
    }

    public static void main(String[] args) throws IOException
    {
        new Main().run();
    }

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    PrintWriter out = new PrintWriter(System.out);
    String next() throws IOException
    {
        while (st == null || !st.hasMoreTokens())
        {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException
    {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException
    {
        return Long.parseLong(next());
    }

    private void run() throws IOException
    {
        solve();
        out.close();
    }

}